import { Command } from 'ckeditor5/src/core';

export default class InsertQBankMediaCommand extends Command {
  execute() {
    const { model } = this.editor;

    //Callback
    var cbAddImageToEditor = function (qbankMedia) {
      model.change((writer) => {
        model.insertContent(
          createQBankMedia(writer, { src: qbankMedia.attributes.src })
        );
      });
    }

    //Open QBank Image selection using connector
    Drupal.ckeditor5.openDialog(
      Drupal.url('qbank_dam/dialog/qbank'),
      cbAddImageToEditor,
      { width: '100%' }
    );
  }

  refresh() {
    const { model } = this.editor;
    const { selection } = model.document;

    // Determine if the cursor (selection) is in a position where adding a image is permitted
    const allowedIn = model.schema.findAllowedParent(
      selection.getFirstPosition(),
      'qbankMedia',
    );

    // set null if not allowed
    this.isEnabled = allowedIn !== null;
  }
}

function createQBankMedia(writer, attributes) {
  //Create Element
  const qbankMedia = writer.createElement(
    'qbankMedia',
    {
      src: attributes.src ?? ''
    }
  );
  return qbankMedia;
}
