(function ($, Drupal, drupalSettings) {
  "use strict";
  var initialized = false;

  Drupal.behaviors.qbankdamSetup = {
    attach: function (context, setting) {

      if (!initialized) {
        initialized = true;

        var dialog_width = jQuery(window).width() - 40;
        var dialog_height = jQuery(window).height() - 20;

        jQuery('.ui-dialog').css({
          'width': dialog_width + 'px',
          'left': '20px',
          'top': '2%',
          'position': 'fixed'
        });

        jQuery(".is-entity-browser-submit").hide();

        //Resize window - alignment and window size fixes
        jQuery(".ui-dialog").addClass("qbank-override-ui-dialog");
        jQuery(".ui-dialog .ui-dialog-content").addClass(
          "qbank-override-ui-dialog-content"
        );


        var setupWindowSize = function () {
          jQuery("#" + drupalSettings.qbank_dam.html_id).css({
            height: "calc(100vh - 100px)",
          });
        };

        var mediaSelected = function (media, image) {
          jQuery("input[name='qbank_url']").val(image[0].url);
          jQuery("input[name='qbank_extension']").val(image[0].extension);
          jQuery("input[name='qbank_title']").val(media.name);
          jQuery("input[name='qbank_media_id']").val(media.mediaId);
          jQuery("input#edit-submit").click();
          jQuery(
            '<div role="contentinfo" aria-label="Status message" class="messages messages--status"><div role="alert"><h2 class="visually-hidden">Status message</h2>Downloading media from QBank DAM</div></div>'
          ).insertAfter("input#edit-submit");
        };

        var protocol =
          drupalSettings.qbank_dam.protocol === "HTTPS" ? "https" : "http";
        var qbcConfig = {
          deploymentSite: drupalSettings.qbank_dam.deployment_site,
          api: {
            host: drupalSettings.qbank_dam.url,
            access_token: drupalSettings.qbank_dam.token,
            protocol: protocol, //drupalSettings.qbank_dam.protocol
          },
          gui: {
            basehref:
              protocol + "://" + drupalSettings.qbank_dam.url + "/connector/",
          },
        };

        var QBC = new QBankConnector(qbcConfig);

        var mediaPicker = new QBC.mediaPicker({
          container: "#" + drupalSettings.qbank_dam.html_id,
          onSelect: mediaSelected,
          onReady: setupWindowSize,
          modules: {
            folders: true,
            categories: true,
            moodboards: true,
            settings: true,
            content: {
              header: false,
              toolbar: true,
              details: true,
            },
            imageTool: {
              crop: true,
            },
            detail: {
              showUseButton: true,
            },
            searchResult: {
              showUseButton: false,
            },
          },
        });
      }

    },
  };
})(jQuery, Drupal, drupalSettings);
